//------------------------------------------------------------------------------
// GPL LICENSE (short)
//------------------------------------------------------------------------------
/*
 * Copyright (c) 2020 R1KO, vadrozh aka NaN

 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 * ChangeLog:
		1.0.0 -	Релиз
		1.1.0 - Новый синтаксис, поддержка [VIP] Core 3.0.1R+
*/
#pragma semicolon 1

#include <sourcemod>
#include <sdkhooks>
#include <vip_core>

#pragma newdecls required

public Plugin myinfo =
{
	name = "[VIP] No Self Damage",
	author = "R1KO, vadrozh aka NaN",
	description = "Выключение урона по себе у VIP-игроков",
	version = "1.1.0",
	url = "https://hlmod.ru"
};

#define VIP_NSD	"NoSelfDamage"

public void OnPluginStart()
{
	for (int i = 1; i <= MaxClients; ++i)
		if (IsValidEntity(i) && IsClientInGame(i))
			OnClientPutInServer(i);
	if(VIP_IsVIPLoaded())
		VIP_OnVIPLoaded();
}

public void OnPluginEnd()
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterMe") == FeatureStatus_Available)
		VIP_UnregisterMe();
}

public void VIP_OnVIPLoaded() { VIP_RegisterFeature(VIP_NSD, BOOL); }

public void OnClientPutInServer(int client)
{
	SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamage);
}

public Action OnTakeDamage(int victim, int &attacker, int &inflictor, float &damage, int &damagetype)
{
	if(0 < attacker <= MaxClients && victim == attacker && VIP_IsClientVIP(victim) && VIP_IsClientFeatureUse(victim, VIP_NSD))
		return Plugin_Handled;
	return Plugin_Continue;
}